"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MockedNetworkInterface = function () {
  function MockedNetworkInterface(createResponse, _ref) {
    var latency = _ref.latency;

    _classCallCheck(this, MockedNetworkInterface);

    this.createResponse = createResponse;
    this.settings = {
      latency: latency ? parseInt(latency, 10) : null
    };
  }

  _createClass(MockedNetworkInterface, [{
    key: "query",
    value: function query(request) {
      var _this = this;

      // eslint-disable-line class-methods-use-this
      var response = this.createResponse(request);
      return new Promise(function (fullfil) {
        if (!_this.settings.latency) return fullfil({ data: response.data }); // resolve immediatelly
        return setTimeout(function () {
          return fullfil({ data: response.data });
        }, _this.settings.latency); // simulate network latency
      });
    }
  }]);

  return MockedNetworkInterface;
}();

exports.default = MockedNetworkInterface;
module.exports = exports["default"];